Unit ListaUni{Type TElem};
(*
  TElem tpus elemekbl ll lista tpusa.
  Lncolt brzols.
  A statikusan lncoltbl, mechanikus trssal kszlt. (L. Memria-modell.)
  Kommentltam az trsi szablyt.
  Importland:
  * Type TElem
  * Memria-modell
*)
 Interface
(*SzP
  Elhagyand:
  Uses
    MemUniL{=>TElem,TListaElem,TCim; Felszabadit,Lefoglal};
*)
  Type
(*SzP
  jdonsg: TElem = String[9]
*)
    TElem     = Record varos:String[30]; Loki,Livi:LongInt End;
(*SzP
  helyettestend:
    TMut      = TCim;
*)
    TMut      = ^TListaElem;
    TListaElem= Record
                  ertek: TElem;
                  kov,elo: TMut
                End;
    TLista    = Record
                  fej,akt : TMut;
                  db      : Integer;
                  hiba    : Boolean;
                End;
    Procedure Ures{legyen}(Var l:TLista);
    Function  UresE{?}(Const l:TLista): Boolean;
    Function  ElemSzam(Const l:TLista): Integer;
    Procedure Elsore{pozicional}(Var l:TLista);
    Procedure Vegere{pozicional}(Var l:TLista);
    Procedure BeszurMoge(Var l:TLista; elem: TElem);
    Procedure BeszurElejere(Var l:TLista; elem: TElem);
    Procedure BeszurEle(Var l:TLista; elem: TElem);
    Procedure Kihagy(Var l:TLista);
    Procedure Kovre{pozicional}(Var l:TLista);
    Procedure Elozore{pozicional}(Var l:TLista);
    Procedure ElemErtek(Var l:TLista; Var elem: TElem);
    Procedure ElemModosit(Var l:TLista; elem: TElem);
    Function  UtolsoE{?}(Var l:TLista): Boolean;
    Function  ElsoE{?}(Var l:TLista): Boolean;
    Function  HibasE{?}(Var l:TLista): Boolean;

  Const
(*SzP
  jdonsg: a Sehova=Nil
*)
    Sehova = Nil;
    UresLista: TLista=(fej:Sehova; akt:Sehova; db:0; hiba:False);

 Implementation

  Procedure lFelszabadit(Var mit: TMut);
  Begin
    If mit<>Sehova then
    Begin
(*SzP
  trs: mem[mit] => mit^  |  Felszabadit(mit) => Dispose(mit)
*)
      lFelszabadit(mit^.kov); Dispose(mit);
    End
  End;

  Procedure Ures{se tesz!}(Var l:TLista);
  Begin
    If l.fej<>Sehova then lFelszabadit(l.fej);
    l.akt:=Sehova;
  End;

  Function UresE{?}(Const l:TLista):Boolean;
  Begin
    UresE:=(l.fej=Sehova)
  End;

  Function ElemSzam(Const l:TLista):Integer;
  Begin
    ElemSzam:=l.db
  End;

  Procedure Elsore{pozicional}(Var l:TLista);
  Begin
    If l.fej=Sehova then l.hiba:=True;
    l.akt:=l.fej
  End;

  Procedure Vegere{pozicional}(Var l:TLista);
  Begin
    If l.fej=Sehova then
    Begin
      l.hiba:=True;
    End
      else
    Begin
      l.akt:=l.fej;
      While not UtolsoE(l) do Kovre(l);
    End;
  End;

  Procedure BeszurMoge(Var l:TLista; elem: TElem);
    Var
      uj : TMut;
  Begin
(*SzP
  trs: Lefoglal(uj) => New(uj)
*)
    New(uj);
    If uj<>Sehova then {van hely:}
    Begin
      If
        l.fej=Sehova then {resbe}
          Begin
            uj^.ertek:=elem; uj^.kov:=Sehova; uj^.elo:=Sehova;
            l.fej:=uj; l.akt:=l.fej;
            Inc(l.db);
          End else if
        l.akt=Sehova then {lelptnk a listrl:}
          Begin {hiba}
            Dispose(uj);
            l.hiba:=True;
          End
        Else
          Begin
            uj^.ertek:=elem; uj^.kov:=l.akt^.kov; uj^.elo:=l.akt;
            If l.akt^.kov<>Sehova then l.akt^.kov^.elo:=uj;
            l.akt^.kov:=uj;
            l.akt:=uj;
            Inc(l.db);
          End;
    End
      else {Nincs szabad hely:}
    Begin
      l.hiba:=True
    End;
  End;{BeszurMoge}

  Procedure BeszurElejere(Var l:TLista; elem: TElem);
    Var
      uj : TMut;
  Begin
    New(uj);
    If uj<>Sehova then {van hely:}
    Begin
      If
        l.fej=Sehova then {resbe}
          Begin
            uj^.ertek:=elem; uj^.kov:=Sehova; uj^.elo:=Sehova;
            l.fej:=uj; l.akt:=l.fej;
            l.db:=1;
          End else if
        l.akt<>Sehova then {van aktulis}
          Begin
            uj^.ertek:=elem; uj^.kov:=l.fej; uj^.elo:=Sehova;
            l.fej^.elo:=uj;
            l.fej:=uj; l.akt:=l.fej;
            Inc(l.db);
          End
       else {nincs aktulis}
          Begin
            l.hiba:=True;
            Dispose(uj);
          End
      {EndIf};
    End
      else {Nincs szabad hely:}
    Begin
      l.hiba:=True
    End;
  End;{BeszurElejere}

  Procedure BeszurEle(Var l:TLista; elem: TElem);
    Var
      uj : TMut;
  Begin
    New(uj);
    If uj<>Sehova then {van hely:}
    Begin
      If
        l.fej=Sehova then {resbe}
          Begin
            uj^.ertek:=elem; uj^.kov:=Sehova; uj^.elo:=Sehova;
            l.fej:=uj; l.akt:=l.fej;
//SzP:
            l.db:=1
//:SzP
          End else if
        l.akt=l.fej then {1. el}
          Begin
            uj^.ertek:=elem; uj^.kov:=l.fej; uj^.elo:=Sehova;
            l.akt^.elo:=uj;
            l.fej:=uj; l.akt:=l.fej;
            Inc(l.db);
          End else if
        l.akt<>Sehova then {van aktulis}
          Begin
            uj^.ertek:=elem; uj^.kov:=l.akt; uj^.elo:=l.akt^.elo;
            {az l.akt nem az 1.} l.akt^.elo^.kov:=uj;
            l.akt^.elo:=uj;
            l.akt:=uj;
            Inc(l.db);
          End
        Else {nincs aktulis}
          Begin
            l.hiba:=True;
            Dispose(uj);
          End
      {EndIf};
    End
      else {Nincs szabad hely:}
    Begin
      l.hiba:=True
    End;
  End;{BeszurEle}

  Procedure Kihagy(Var l:TLista);
    Var
       ki : TMut;
  Begin
    If (l.fej<>Sehova) and (l.akt<>Sehova) then
    Begin
      ki:=l.akt;
      l.akt:=l.fej;
      If l.akt=ki then {az 1. elem a kihagyand}
      Begin
        Dispose(l.fej); l.fej:=l.akt^.kov; l.akt:=l.fej;
      End
         Else
      Begin
        While l.akt^.kov<>ki do l.akt:=l.akt^.kov;
        l.akt^.kov:=ki^.kov;
        Dispose(ki);
      End;
      Dec(l.db);
    End
        Else
    Begin
      l.hiba:=True
    End;
  End;{Kihagy}

  Procedure Kovre{pozicional}(Var l:TLista);
  Begin
    If l.akt<>Sehova then l.akt:=l.akt^.kov
                     else l.hiba:=True;
  End;

  Procedure Elozore{pozicional}(Var l:TLista);
  Begin
    If l.akt<>Sehova then l.akt:=l.akt^.elo
                     else l.hiba:=True;
  End;

  Procedure ElemErtek(Var l:TLista; Var elem: TElem);
  Begin
    If l.akt<>Sehova then elem:=l.akt^.ertek
                     else l.hiba:=True;
  End;

  Procedure ElemModosit(Var l:TLista; elem: TElem);
  Begin
    If l.akt<>Sehova then l.akt^.ertek:=elem
                     else l.hiba:=True;
  End;

  Function UtolsoE{?}(Var l:TLista): Boolean;
  Begin
    If l.fej=Sehova then l.hiba:=True;
    UtolsoE:=(l.akt^.kov=Sehova)
  End;

  Function  ElsoE{?}(Var l:TLista): Boolean;
  Begin
    If l.fej=Sehova then l.hiba:=True;
    ElsoE:=(l.akt^.elo=l.fej)
  End;

  Function HibasE{?}(Var l:TLista): Boolean;
  Begin
    HibasE:=l.hiba; l.hiba:=False;
  End;

Begin
End.
